from .utils import gen_uid


class BaseRecipientsGroup(object):
    """ """
    model = None
    prefix = ''
    namespace = None

    def __init__(self):
        self.name = self.__class__.__name__

    def get_queryset(self):
        return self.model._default_manager.all()

    def search(self, query, group_object_id):
        return self.get_queryset()

    def get_object(self, pk):
        return self.get_queryset().filter(pk=pk).first()

    def check_permission(self, user):
        return True

    def get_user_ids(self, obj):
        raise NotImplementedError

    def get_group_object(self, obj):
        raise NotImplementedError

    def to_json(self, qs):
        items = []
        for item in qs:
            items.append({
                'id': gen_uid(self.__class__, item.pk),
                'text': "{} {}".format(self.prefix, self.get_label(item))
                               .strip()
            })
        return items

    def get_label(self, obj):
        return obj.__str__()
