from __future__ import unicode_literals

from django import template

from evotemessages.models import Message


register = template.Library()


@register.simple_tag(takes_context=True)
def inbox_unread_count(context, namespace=None, group_object=None):
    """ """
    return unread_count(context, Message.objects.inbox, namespace,
                        group_object)


@register.simple_tag(takes_context=True)
def sentbox_unread_count(context, namespace=None, group_object=None):
    """ """
    return unread_count(context, Message.objects.sentbox, namespace,
                        group_object)


@register.simple_tag(takes_context=True)
def archivedbox_unread_count(context, namespace=None, group_object=None):
    """ """
    return unread_count(context, Message.objects.archivedbox, namespace,
                        group_object)


def unread_count(context, box, namespace=None, group_object=None):
    user = context['request'].user
    namespace = namespace or context['contact_namespace']
    return box(user, namespace, group_object).unread().count()
